//////////////////////////////////////////
//fBXvC̉𑜓xύXNX
//2003/09/04 Goroxo
//2004/01/17 GetWidth,GetHeight,GetBit
//           ł̕sCB
//////////////////////////////////////////
#include <windows.h>
#include "Display.h"

//݂̃fBXvC̕擾
//p[^	
//߂l		ʂ̕
int DisplayMode::GetWidth()
{
	HDC DesktopDC=GetDC( NULL );
	int Width=GetDeviceCaps( DesktopDC , HORZRES );
	ReleaseDC( NULL , DesktopDC );
	return Width;
}

//݂̃fBXvC̍擾
//p[^	
//߂l		ʂ̍
int DisplayMode::GetHeight()
{
	HDC DesktopDC=GetDC( NULL );
	int Height=GetDeviceCaps( DesktopDC , VERTRES );
	ReleaseDC( NULL , DesktopDC );
	return Height;
}

//݂̃fBXvC̃rbg擾
//p[^	
//߂l		ʂ̃rbg
int DisplayMode::GetBit()
{
	HDC DesktopDC=GetDC( NULL );
	int Bit=GetDeviceCaps( DesktopDC , BITSPIXEL );
	ReleaseDC( NULL , DesktopDC );
	return Bit;
}

//w肵fBXvC[h̕擾
//p[^	int n	fBXvC[h̃Xgԍ
//߂l		ʂ̕
int DisplayMode::GetWidth( int n )
{
	if( n>=0 && n<GetDisplayModeNumber() )
		return ModeList[ n ].dmPelsWidth;
	return 0;
}

//w肵fBXvC[h̍擾
//p[^	int n	fBXvC[h̃Xgԍ
//߂l		ʂ̍
int DisplayMode::GetHeight( int n )
{
	if( n>=0 && n<GetDisplayModeNumber() )
		return ModeList[ n ].dmPelsHeight;
	return 0;
}

//w肵fBXvC[h̃rbg擾
//p[^	int n	fBXvC[h̃Xgԍ
//߂l		ʂ̃rbg
int DisplayMode::GetBit( int n )
{
	if( n>=0 && n<GetDisplayModeNumber() )
		return ModeList[ n ].dmBitsPerPel;
	return 0;
}

//ύXłfBXvC[h
//p[^	Ȃ
//߂l		ύXłfBXvC[h̐
int DisplayMode::GetDisplayMode()
{
	DisplayModeNumber = 0;
	while( EnumDisplaySettings( NULL , DisplayModeNumber , &ModeList[ DisplayModeNumber ] ) ){
		if(ModeList[ DisplayModeNumber ].dmBitsPerPel == (unsigned long)GetBit() && 
			ModeList[ DisplayModeNumber ].dmPelsWidth == (unsigned long)GetWidth() &&
			ModeList[ DisplayModeNumber ].dmPelsHeight == (unsigned long)GetHeight() )
			OldMode = ModeList[ DisplayModeNumber ];
		DisplayModeNumber++;
	}
	return DisplayModeNumber;
}

//fBXvC[hN܂͗񋓎̂̂ɕύX
//p[^	Ȃ
//߂l		DISP_CHANGE_SUCCESSFULA
int DisplayMode::ChangeDisplayMode()
{		
	if(OldMode.dmBitsPerPel == (unsigned long)GetBit() && 
		OldMode.dmPelsWidth == (unsigned long)GetWidth() &&
		OldMode.dmPelsHeight == (unsigned long)GetHeight() )
		return 0;
	if(ChangeDisplaySettings( &OldMode , CDS_TEST ) == DISP_CHANGE_SUCCESSFUL)
		return ChangeDisplaySettings( &OldMode, 0 );
	return 0;
}

//fBXvC[hXgԍw肵ĕύX
//p[^	Ȃ
//߂l		DISP_CHANGE_SUCCESSFULA
int DisplayMode::ChangeDisplayMode( int n )
{
	if( n>=0 && n<GetDisplayModeNumber() )
		if(ChangeDisplaySettings( &ModeList[ n ] , CDS_TEST ) == DISP_CHANGE_SUCCESSFUL)
			return ChangeDisplaySettings( &ModeList[ n ], 0 );
	return 0;
}

//fBXvC[hʂ̕AArbgw肵ĕύX
//p[^	Ȃ
//߂l		DISP_CHANGE_SUCCESSFULA
int DisplayMode::ChangeDisplayMode( int w , int h , int b )
{
	for( int i=0;i<GetDisplayModeNumber();i++ )
		if( GetWidth( i )==w && GetHeight( i )==h && GetBit( i )==b )
			return ChangeDisplayMode( i );
	return 0;
}
